*
* 5719-LM7 COPYRIGHT IBM CORP 1979, 1980, 1981V3M1RMF
* 5740-LM4 COPYRIGHT IBM CORP 1979, 1980, 1981			V3M1RMF
* LICENSED MATERIAL - PROGRAM PROPERTY OF IBM
* REFER TO COPYRIGHT INSTRUCTIONS FORM #G120-2083
* VERSION = 03.1 MODIFIED
*
* CHANGE ACTIVITY:
*
*    DATE    REASON  ID		    CHANGE SUMMARY
*
*  03/19/80   V3M0   GDD  ADDED FIELDS AND UPDATED DISPLACEMENTS
*			  FOR 3101, SPOOLING, AND ACCA
*
*  05/12/80 PTR00133 GDD  ASSIGNED BIT 7 OF $CCBFET2 FOR TTY CONTROL
*
*  05/15/80 PTR00165 GDD  ASSIGNED BIT 1 OF $CCBOPTS FOR CLEAR
*			  LINE AT ATTN
*
*  06/05/80 PTR00357 GDD  CORRECTED COMMENTS ON $CCBOPTS BITS 14 AND 15
*
*  02/10/81 S2024107 JWW  ADD S1-S1 EQUATES
*
*  05/01/81 V3M1RMF  RMF  ADD FLAG TO INDICATE IF TERMINAL HAS BEEN
*			  VARY'ED OFF BY $TERMUT1
*
*  06/30/81 V3M2JWW  JWW  ADD CODE FOR V3.2 4975 QUALITY PRINT
*
$CCB	 EQU   0	       ORIGIN OF CCB
$CCBS1S1 EQU   $CCB-174		   S/1 - S/1 DATA	       @S202410
$CCBS1HD EQU   $CCBS1S1		   HEADER WORD 1	       @S202410
*				   BITS 0-1  = 0	       @S202410
*				   BIT	2    = IF BIT	       @S202410
*					     = 0 = READ ISSUED @S202410
*					     = 1 = WRITE ISSUED@S202410
*				   BIT	3    = 1 = CHECKSUM ON @S202410
*				   BITS 4-7  = CHKSUM LENGTH   @S202410
*				   BITS 8-15 = PROGRAM DATA    @S202410
*							       @S202410
$CCBS1CT EQU   $CCBS1HD+2	   HEADER WORD 2 - BYTE COUNT  @S202410
$CCBS1F1 EQU   $CCBS1CT+2	   FLAG WORD 1		       @S202410
*				   BIT 0 = 1 = ATTENTION PROC. @S202410
*				   BIT 0 = 0 = NO ATTN. PROC.  @S202410
*							       @S202410
*				   BITS 1-2  = RESERVED(=0)    @S202410
*							       @S202410
*				   BIT 3 = 0 = CHKSUM OFF      @S202410
*					   1 = CHKSUM ON       @S202410
*							       @S202410
*				   BITS 4-7  = CHKSUM BITS     @S202410
*					     0000 = 32 BYTES   @S202410
*					     0001 = 16 BYTES   @S202410
*					     0011 = 8  BYTES   @S202410
*					     0111 = 4  BYTES   @S202410
*					     1111 = 2 BYTES    @S202410
*							       @S202410
*				   BIT 9 = 0 = TIMEOUT	       @S202410
*					   1 = NO TIMEOUT      @S202410
*					   (UNSUPPORTED BY EDX)@S202410
*							       @S202410
*				   BITS 10-11 - RESERVED(=0)   @S202410
*							       @S202410
*				   BIT 12 = 1 = IPL INIT DONE  @S202410
*					    0 = NOT DONE YET   @S202410
*							       @S202410
*				   BIT 13 = 1 = IPL INIT FAILED@S202410
*						IPL INIT OK    @S202410
*							       @S202410
*				   BITS 14-15 - RESERVED       @S202410
*							       @S202410
$CCBS1F2 EQU   $CCBS1F1+2	   FLAG WORD 2 - RESERVED      @S202410
$CCBS1LS EQU   $CCBS1F2+2	   LSR AFTER OIO OR INTERRUPT  @S202410
$CCBS1SW EQU   $CCBS1LS+2	   ISW AFTER INTERRUPT	       @S202410
*				   BITS 0-7  = ISB/IIB	       @S202410
*				   BITS 8-15 = DEVICE ADDRESS  @S202410
*							       @S202410
$CCBS1JR EQU   $CCBS1SW+2	   DIAG. READ JUMPER RESULT    @S202410
*							       @S202410
*				   BITS 0-7		       @PT00674
*				    = 00000000 = RPQ D02242    @PT00674
*				    = 00000001 = RPQ D02241    @PT00674
*				    = 00000010 = RPQ D02241    @PT00674
*				    = 00000011 = GPIB	       @PT00674
*				   BIT 8 = ACTIVE D02241(MAST) @PT00674
*				   BIT 9 = ACTIVE D02242(SLA)  @PT00674
*				   BIT 10= ENABLE D02242 REQ.  @PT00674
*				   BIT 11= CHKSUM ERROR DETECT @PT00674
*				   BIT 12= D02242 REQUEST      @PT00674
*				   BIT 13= NOT READY FOR DATA  @PT00674
*				   BIT 14= NOT DATA ACCEPTED   @PT00674
*				   BIT 15= DATA VALID	       @PT00674
*							       @S202410
$CCBS1RT EQU   $CCBS1JR+2	   RETRY COUNTER FOR READ JUMP @S202410
$CCBS1PR EQU   $CCBS1RT+2	   PREP LEVEL SAVE AREA        @S202410
$CCBS1D1 EQU   $CCBS1PR+2	   SAVE AREA 1		       @S202410
$CCBS1D2 EQU   $CCBS1D1+2	   SAVE AREA 2		       @S202410
$CCBS1JI EQU   $CCBS1D2+2	   IDCB FOR DIAG. READ JUMPER  @S202410
$CCBS1EI EQU   $CCBS1JI+4	   IDCB FOR EC PATCH	       @S202410
*				   AT IPL TIME: IDCB FOR PATCH @S202410
*				   POINTS TO		       @S202410
*				   DCB/DATA IN "TERMINIT" TO   @S202410
*				   DO DIAG. PATCH AT IPL       @S202410
*				   AT EXECUTION TIME:	       @S202410
*				   UPON ATTENTION INTERRUPT    @S202410
*				     RECEPTION; NOTIFY USER    @S202410
*				   WORD 0: B13-15 - ECB KEY    @S202410
*				   WORD 1: ECB ADDRESS	       @S202410
$CCBS1ED EQU   $CCBS1EI+4	   DCB FOR DIAG. READ JUMPER   @S202410
$CCBS1CD EQU   $CCBS1ED+16	   DCB FOR CYCLE STEAL STATUS  @S202410
*							       @S202410
*							       @S202410
*	 SERIES/1-SERIES/1 CSS HAS 11 WORDS		       @S202410
*							       @S202410
*	 CSS WORD 0 = RESIDUAL ADDRESS			       @S202410
*		  1 = RESIDUAL BYTE COUNT		       @S202410
*		  2 = NOT USED				       @S202410
*		  3 = NOT USED				       @S202410
*		  4 = BIT 0 = ACCEPTOR HANDSHAKE TIMEOUT       @S202410
*			  1 = RESERVED			       @S202410
*			  2 = SOURCE HANDSHAKE TIMEOUT	       @S202410
*			  3-15 - RESERVED = 0		       @S202410
*		  5 = LINE STATUS AFTER POWER ON (GA34-1561)   @S202410
*		  6 = CURRENT LINE STATUS (GA34-1561)	       @S202410
*		  7 = BITS 0-7	= ABORT CODE IF ANY	       @S202410
*			   8-15 = NOT USED		       @S202410
*		  8 = BITS 0-3	= DCB SPEC CHECK CAUSE	       @S202410
*			   0000 = NOT USED		       @S202410
*			   0001 = ODD DCB ADDRESS	       @S202410
*			   0010 = INVALID PCI BIT	       @S202410
*			   0011 = INVALID IF BIT	       @S202410
*			   0100 = INVALID XD BIT	       @S202410
*			   0101 = INVALID SE BIT	       @S202410
*			   0110 = INVALID DCB WORD 0 BIT 8     @S202410
*			   0111 = INVALID TIMER BIT	       @S202410
*			   1000 = INVALID DCB WORD 0 BIT 10    @S202410
*			   1001 = NON-ZERO UNUSED WORD	       @S202410
*			   1011 = ODD CHAINING ADDRESS	       @S202410
*			   1100 = INVALID BYTE COUNT	       @S202410
*			   1101 = INVALID CMD CODE FOR CONFIG. @S202410
*			   1110 = NOT USED		       @S202410
*			   1111 = NOT USED		       @S202410
*			   1001 = NON-ZERO UNUSED WORD	       @S202410
*			   4-8	= NOT USED = 0		       @S202410
*			   9-11 =			       @S202410
*			   000	= NOT USED		       @S202410
*			   001	= INVALID HEADER IF BIT        @S202410
*			   010	= INVALID CHECK BIT	       @S202410
*			   011	= INVALID CHECKSUM	       @S202410
*			   100	= INVALID PROGRAM WORD	       @S202410
*			   101 - 111 = NOT USED		       @S202410
*			   12-15= NOT USED = 0		       @S202410
*							       @S202410
*		  9 = BITS 0-3	= RESERVED		       @S202410
*		      BIT  4	= OTHER SYSTEM NOT ACTIVE      @S202410
*			   5	= INVALID COMMAND SEQUENCE     @S202410
*			   6	= CHECKSUM ERROR DETECTED      @S202410
*			   7	= NOT USED		       @S202410
*			   8-15 = CHECKSUM BYTE USED	       @S202410
*		  10 = ADDRESS OF LAST DCB USED		       @S202410
*							       @S202410
$CCBS1CS EQU   $CCBS1CD+16	   ADD 3 WORDS FOR S1S1        @S202410
$CCBS1L  EQU   *-$CCBS1S1	   LENGTH OF S1S1 AREA	       @PT00106
$CCB3DC0 EQU   $CCB-152        THIRD 8-WORD DCB FOR 3101B      V3M0GDD
$CCBATTR EQU   $CCB3DC0+16     ATTRIBUTE BYTE FOR 3101B        V3M0GDD
$CCBSTRM EQU   $CCBATTR+1      STREAM CONTROL BYTE FOR 3101B   V3M0GDD
$CCBSCT1 EQU   $CCB-134        #CCBDCB1, #CCBDCB2 SAVE (ACCA)  V3M0GDD
$CCBSCT2 EQU   $CCBSCT1+4      #CCBDCB3, #CCBDCB4 SAVE (ACCA)  V3M0GDD
$CCBATIO EQU   $CCBSCT2+4      IDCB AND DCB TO READ ATTN (ACCA) V3M0GDD
$CCBLST0 EQU   $CCB-106        8-WORD DEVICE STATUS	       V3M0GDD
$CCB4975 EQU   $CCBLST0-12     4975 DEVICE DEPENDENT WORDS    @V3M2JWW
$CCB75CT EQU   $CCB4975+0      4975 CONTROL WORD	      @V3M2JWW
$CCB75D3 EQU   $CCB4975+2      4975 DCB WORD 3 SAVE	      @V3M2JWW
$CCB75D4 EQU   $CCB4975+4      4975 DCB WORD 4 SAVE	      @V3M2JWW
$CCB75Q0 EQU   $CCB4975+6      4975 RESERVED		      @V3M2JWW
$CCB75Q1 EQU   $CCB4975+8      4975 RESERVED		      @V3M2JWW
$CCB75Q2 EQU   $CCB4975+10     4975 RESERVED		      @V3M2JWW
$CCBSTW0 EQU   $CCBLST0+10     3-WORD DEVICE STATUS
$CCBDCB0 EQU   $CCBSTW0+6      DCB WORD 0		      @V3M2JWW
$CCBDCB1 EQU   $CCBSTW0+8      DCB WORD 1		      @V3M2JWW
$CCBDCB2 EQU   $CCBSTW0+10     DCB WORD 2		      @V3M2JWW
$CCBDCB3 EQU   $CCBSTW0+12     DCB WORD 3		      @V3M2JWW
$CCBDCB4 EQU   $CCBSTW0+14     DCB WORD 4		      @V3M2JWW
$CCBDCB5 EQU   $CCBSTW0+16     DCB WORD 5		      @V3M2JWW
$CCBDCB6 EQU   $CCBSTW0+18     DCB WORD 6		      @V3M2JWW
$CCBDCB7 EQU   $CCBSTW0+20     DCB WORD 7		      @V3M2JWW
$CCBPREP EQU   $CCBDCB0+16     PREPARE I/O IDCB
$CCBRSET EQU   $CCBPREP+4      RESET IDCB
$CCBRDID EQU   $CCBRSET+4      READ-ID IDCB
$CCBSTRT EQU   $CCBRDID+4      START-CS IDCB
$CCBWRIT EQU   $CCBSTRT        WRITE-DATA IDCB
$CCBSTST EQU   $CCBWRIT+4      START-CS-STATUS IDCB
$CCBREAD EQU   $CCBSTST        READ-DATA IDCB
$CCBLDEL EQU   $CCBREAD+4      LINE-DELETE CHAR
$CCBCDEL EQU   $CCBLDEL+1      CHAR-DELETE CHAR
$CCBSKIP EQU   $CCBCDEL+1      CARRIAGE-RETURN, LINE-FEED CHARS
$CCBCTRL EQU   $CCBSKIP        DCB CTRL BITS (4979,4978)
$CCBSKLN EQU   $CCBCTRL+2      NR CHARS IN NEWLINE SEQ (2 + NR IDLES)
$CCBIDLE EQU   $CCBSKLN+1      IDLE CHAR
$CCBHKEY EQU   $CCBIDLE        HARDCOPY KEY CODE
$CCBFEAT EQU   $CCBHKEY+1      FEATURE INDICATORS
*			       BIT 0 - ATTN OFF
*				   1 - 2741 TYPE (ASYNC)
*				   2 - INHIBIT SYSTEM FUNCTIONS
*				   3 - INHIBIT GLOBAL FUNCTIONS
*				   4 - PROMPT OPTION (SYNC=YES) V3M0GDD
*				   5 - OUTPUT PAUSE
*				   6 - ENTER KEY = $PF0 (4978/4979)
*				   7 - NO ECHO
$CCBFET2 EQU   $CCBFEAT+1      SECOND FEATURE INDICATORS       V3M0GDD
*		       BIT 0 - MODE = 3101C		       V3M0GDD
*			   1 - MODE = 3101B		       V3M0GDD
*			   2 - SPOOLABLE DEVICE (PRINTER)      V3M0GDD
*			   3 - THIS IS A SPOOL DEVICE	       V3M0GDD
*			   4 - THIS IS A SPOOL PSEUDO CCB      V3M0GDD
*			   5 - ATTN BYTE 0 WAS RECEIVED        V3M0GDD
*			   6 - PF1 BYTE 0 WAS RECEIVED	       V3M0GDD
*			   7 - TTY CONTROL BYTE WAS RECEIVED   PTR00133
*							       V3M0GDD
* THE FOLLOWING BIT MASKS ARE FOR THE FLAG BITS IN $CCBFET2:   V3M0GDD
*							       V3M0GDD
$CCB31CH EQU   X'80'	       MODE = 3101C		       V3M0GDD
$CCB31BL EQU   X'40'	       MODE = 3101B		       V3M0GDD
$CCBSPLA EQU   X'20'	       SPOOLABLE DEVICE (PRINTER)      V3M0GDD
$CCBSPLD EQU   X'10'	       THIS IS A SPOOL DEVICE	       V3M0GDD
$CCBSPLC EQU   X'08'	       THIS IS A SPOOL PSEUDO CCB      V3M0GDD
$CCBATRC EQU   X'04'	       ATTN BYTE 0 WAS RECEIVED        V3M0GDD
$CCBPFRC EQU   X'02'	       PF1 BYTE 0 WAS RECEIVED	       V3M0GDD
$CCBTYRC EQU   X'01'	       TTY CONTROL BYTE WAS RECEIVED   PTR00133
*							       V3M0GDD
$CCBOLCT EQU   $CCBFET2+1      CURRENT OUTPUT LINE COUNT       V3M0GDD
$CCBBDIS EQU   $CCBOLCT+1      BUFFER DISPLACEMENT	       V3M0GDD
$CCBCODE EQU   $CCBBDIS+1      ADDR CODE XLATE TABLE (0=EBCDIC) V3M0GDD
$CCBIOCB EQU   $CCBCODE+2      IOCB (MODIFIED)
$CCBFLGS EQU   $CCBIOCB        FLAGS
*			       BIT 0 - IOCB PRESENT
*				   1 - RESERVED
*				   2 - RESERVED
*				   3 - RESERVED
*				   4 - STATIC SCREEN
*				   5 - RESERVED
*				   6 - OVERFLOW LINES
*				   7 - TERMINAL VARY'ED OFF	V3M1RMF
$CCBTWRK EQU   $CCBFLGS+1      TOP OF WORKING AREA (LINE NR)
$CCBTOPM EQU   $CCBTWRK+1      TOP MARGIN
$CCBBOTM EQU   $CCBTOPM+1      BOTTOM MARGIN
$CCBLFTM EQU   $CCBBOTM+1      LEFT MARGIN
$CCBPSIZ EQU   $CCBLFTM+1      CURRENT PAGE SIZE
$CCBBLEN EQU   $CCBPSIZ+1      CURRENT LINE SIZE
$CCBNXTL EQU   $CCBBLEN+2      NEXT LINE POSITION
$CCBCPOS EQU   $CCBNXTL+1      CURSOR DISPLACEMENT
$CCBBSIZ EQU   $CCBCPOS+1      CURRENT BUFFER SIZE	       V3M0GDD
$CCBIICB EQU   $CCBBSIZ+2      INITIAL IOCB		       V3M0GDD
$CCBPMAX EQU   $CCBIICB+12     MAXIMUM PAGE SIZE	       V3M0GDD
$CCBLMAX EQU   $CCBPMAX+1      MAXIMUM LINE SIZE
$CCBNAME EQU   $CCBLMAX+1      TERMINAL NAME (EBCDIC)
$CCBOPTS EQU   $CCBNAME+8     CURRENT INSTRUCTION OPTIONS
*		      BIT 0 - LEN PARAMETER		       V3M0GDD
*			  1 - CLEAR LINE AT ATTN	       PTR00165
*			  2 - NO XLATE
*			  3 - WRITE PROTECT / READ NOECHO
*			  4, 5 - TYPE PARAMETER, BIT SETTINGS: V3M0GDD
*			    01 - TYPE = ALL		       V3M0GDD
*			    10 - TYPE = MODDATA		       V3M0GDD
*			    11 - TYPE = MODALL		       V3M0GDD
*			  6 - WAIT INDICATOR		       V2M1 PTF
*			  7 - LOCAL BUFFER		       1.1
*			  8 - INPUT INSTRUCTION
*			  9 - HARDCOPY FUNCTION
*			 10 - WAIT KEY
*			 11 - ROLL SCREEN OP TO STATIC SCREEN
*			 12 - DIRECT USER BUFFER READ OR WRITE
*			 13 - READ ADVANCE INPUT, NO POP
*			 14 - MODE=LINE (OUTPUT)	       PTR00357
*			 15 - MODE=LINE (INPUT)		       PTR00357
$CCBERCD EQU   $CCBOPTS+2      ERROR CODE
$CCBERCT EQU   $CCBERCD+2      ERROR COUNT
$CCBLINK EQU   $CCBERCT+2      LINK TO NEXT CCB (0=END)
$CCBIA	 EQU   $CCBLINK+2      IMMEDIATE ACTION ADDRESS
$CCBDVID EQU   $CCBIA+2        DEVICE ID
$CCBIOS  EQU   $CCBDVID+2      START-I/O ENTRY
$CCBEXRW EQU   $CCBIOS+2       INDEX TO READ/WRITE ENTRY (IOSTERM)
$CCBTAG  EQU   $CCBEXRW+2      BLOCK TYPE (-1 = CCB)
$CCBESC  EQU   $CCBTAG+2       RESERVED
$CCBPOST EQU   $CCBESC+2       CALL TO POST ROUTINE
$CCBWAIT EQU   $CCBPOST+24     CALL TO WAIT ROUTINE		    1.1
$CCBATCH EQU   $CCBWAIT+22     CALL TO ATTACH ROUTINE		    1.1
$CCBKBT  EQU   $CCBATCH+22     ADDRESS OF KEYBOARD TASK        V3M0GDD
$CCBHCPY EQU   $CCBKBT+2       ADDR HARDCOPY OR VIRTUAL CCB
$CCBECB  EQU   $CCBHCPY+2      I/O EVENT CONTROL BLOCK
$CCBQCB  EQU   $CCBECB+6       I/O QUEUE CONTROL BLOCK
$CCBQUIN EQU   $CCBQCB+10      PTR TO TCB OF USER IN CONTROL
$CCBIMF1 EQU   $CCBQUIN+4      IMF DATA
$CCBATTN EQU   $CCBIMF1+2      ATTN KEY CODE
$CCBPF1  EQU   $CCBATTN+2      BASE FOR PF KEYS		       V3M0GDD
$CCBFLD  EQU   $CCBPF1+2       TEMPORARY STORAGE	       V3M0GDD
$CCBRS0  EQU   $CCBFLD+12      REGISTER SAVE AREA
$CCBISV0 EQU   $CCBRS0+10      REGISTER SAVE AREA
$CCBS0	 EQU   $CCBISV0+10     REGISTER SAVE AREA
$CCBMSIZ EQU   $CCBS0+16       NR CHARS IN BUFFER (NEG IF INPUT)
$CCBBORG EQU   $CCBMSIZ+2      CURRENT BUFFER START
$CCBBFAD EQU   $CCBBORG+2      INITIAL BUFFER START
$CCBBKEY EQU   $CCBBFAD+2      BUFFER ADDR KEY			    1.1
$CCBSTA  EQU   $CCBBKEY+2      BUFFER STATE INDICATORS		    1.1
$CCBCTLB EQU   $CCBSTA+2       TWO-BYTE CONTROL BUFFER
$CCBTBUF EQU   $CCBCTLB+2      SYSTEM BUFFER
