	 EJECT
*	 SUBROUT  OPCHECK
*
*  SUBROUTINE TO 1) COMPARE THE NUMBER OF POSITIONAL OPERANDS
*  IN THE SOURCE STATEMENT AGAINST THE ALLOWABLE NUMBER OF
*  POSITIONAL OPERANDS, 2) MATCH KEYWORDS SPECIFIED IN
*  THE SOURCE AGAINST THE ALLOWABLE KEYWORDS, AND 3) STORE
*  THE 'OLE' AND 'SLE' ADDRESSES IN THE $IDEF EXPANSION FOR
*  EACH OPERAND CODED IN THE SOURCE STATEMENT.
*
*  CALLING SEQUENCE:
*
*	 CALL	OPCHECK,(OPLIST)
*
*     WHERE
*	 OPLIST IS THE LABEL ON A $IDEF STATEMENT
*	 DEFINING THE MODEL FOR AN INSTRUCTION
*
*  ENTRY CONDITIONS
*    NONE
*
*  EXIT CONDITIONS
*    1) NORMAL EXIT
*	EACH POSITIONAL AND KEYWORD OPERAND SPECIFIED
*	IN THE SOURCE STATEMENT WILL HAVE ITS ENTRY IN
*	THE $IDEF EXPANSION FILLED IN WITH ITS 'OLE'
*	AND 'SLE' ADDRESS. IF THE OPERAND IS MISSING
*	THE CORRESPONDING ENTRY IN $IDEF WILL BE ZERO.
*
*    2) ABNORMAL EXIT
*	IF AN INVALID NUMBER OF POSITIONAL OPERANDS IS
*	CODED, BRACH TO 'POSITIONAL' ERROR EXIT AS
*	DEFINED IN $IDEF.  IF AN INVALID KEYWORD IS CODED,
*	BRANCH TO 'KEYWORD' ERROR EXIT DEFINED IN $IDEF.
*
*  REGISTERS USED
*    #2 IS USED
*
	 EJECT
	 SPACE 3
	 SUBROUT   OPCHECK,AOPLIST
*
	 MOVE	   KWSAVE#1,#1
*
	 MOVE	   #2,AOPLIST	       POINT TO USERS PROTOTYPE LIST
*
*				       IF THERE ARE ANY POSITIONAL
*				       PARAMETERS, RESET ALL TO '0'
	 IF	   ((0,#2),GT,0)
	   ADD	     (0,#2),(0,#2),RESULT=CLEARCNT
	   MOVE      (6,#2),0,1,P3=CLEARCNT
	 ENDIF
*
*				      IF TOO MANY POSITIONAL WERE CODED
*				       GO TO USER'S ERROR ROUTINE
	 IF	   (OPTABLE+#POSIT,GT,(0,#2))
	   MOVE      GOTOPTR,(2,#2)
	   GOTO      *,P1=GOTOPTR
	 ENDIF
*
	 SHIFTL    (0,#2),2,RESULT=OPCSAV#2
	 ADD	   #2,6
	 ADD	   OPCSAV#2,#2
*
	 MOVEA	   #1,OPTABLE+10
*
	 IF	   (OPTABLE,GT,0)
	   DO	     OPTABLE+#POSIT,TIMES
	     MOVE      (0,#2),#1
	     ADD       #1,+LOLE,RESULT=OPC#1
	     MOVE      #1,(OLESLE,#1)
*
	     IF        ((SLELENG,#1),EQ,0),AND,((SLECHAIN,#1),EQ,0)
	       MOVE	 (2,#2),0
	     ELSE
	       MOVE	 (2,#2),#1
	     ENDIF
*
	     MOVE      #1,0,P2=OPC#1
	     ADD       #2,4
	   ENDDO
	 ENDIF
*
	 MOVE	   #2,OPCSAV#2
*
	 DO	   WHILE,((0,#2),NE,X'FFFF')
	   MOVE      (0,#2),0,2
	   ADD	     #2,12
	 ENDDO
*
	 IF	   (OPTABLE+#KEYWD,GT,0)
*
	   DO	     OPTABLE+#KEYWD,TIMES
	     MOVE      #2,1,P2=OPCSAV#2
*
	     DO        WHILE,((0,#2),NE,X'FFFF')
	       MOVE	 IFTEST+2,(OLEKEYWD,#1)
IFTEST	       IF	 (*,EQ,(4,#2),8)
		 MOVE	   (0,#2),#1
		 MOVE	   (2,#2),(OLESLE,#1)
		 ADD	   #1,+LOLE
		 GOTO	   KWDSR2
	       ENDIF
*
	       ADD	 #2,12
	     ENDDO
*
	     MOVE      #2,AOPLIST
	     MOVE      KWDSR1,(4,#2)
	     MOVE      #2,(OLEKEYWD,#1)
	     MOVE      #1,KWSAVE#1
	     GOTO      *,P1=KWDSR1
*
KWDSR2	 EQU	   *
	 ENDDO
	 ENDIF
	 MOVE	   #2,0
	 MOVE	   #1,1,P2=KWSAVE#1
	 RETURN
*
