	 TITLE	   'SUBROUTINE - ***** FINDSPAC *****'
	 SPACE 3
	 SUBROUT   FINDSPAC,#SPACERQ			       V3M0GRB
*
*  SUBROUTINE TO FIND FREE SPACE FOR A NEW MEMBER OF A DATA SET
*
*
*  5719-LM7 COPYRIGHT IBM CORP 1979, 1980		       PT00070
*  5740-LM4 COPYRIGHT IBM CORP 1979, 1980		       PT00070
*  LICENSED MATERIAL - PROGRAM PROPERTY OF IBM		       PT00070
*  REFER TO COPYRIGHT INSTRUCTIONS FORM #G120-2083	       PT00070
*
*	 ENTRY CONDITIONS
*  'FINDSPAC' IS CALLED WITH ONE PARAMETER, #SPACERQ. #SPACERQ V3M0GRB
*  IS A POINTER TO A DW CONTAINING THE REQUESTED SPACE RECORD  V3M0GRB
*  COUNT.						       V3M0GRB
*
*	 EXIT CONDITIONS
*  IF SPACE WAS FOUND,
*   1) $FPMS = ADDRESS OF THE FIRST RECORD  (DW)	       V3M0GRB
*   2) $FPME = ADDRESS OF THE LAST RECORD   (DW)	       V3M0GRB
*   3) THE 'FSE' CHAIN WILL HAVE BEEN APPROPRIATELY REWRITTEN
*   4) THE 'DCE' WILL HAVE BEEN UPDATED.
*
*  IF SPACE WAS NOT FOUND,
*   $FPMS = 0
*   $FPME = 0
*
************
*  CHANGE ACTIVITY:
*  MODIFY FOR DATA SETS > 32K RECORDS, DATA MGMT ENHANCEMENT.
*  GRB	2/14/80  V3M0
*  GRB	5/5/80	 PTR00070 ADD COPYRIGHT COMMENT STATEMENT  GRB
*  GRB	5/16/80  PTR00190 FIX RTFSE TO COMBINE CONTIG FSE'S
*
*
	 SPACE 1
*  ARE THERE ANY FREE ENTRIES?
*
	 IF	   $FPDF,EQ,0,FSPACE04
	 SPACE 1
*  ..YES, INITIALIZE FOR A SEARCH
*
	 MOVE	   FSEFREE,$FPDF       INITIALIZE SEARCH COUNT
	 SPACE 1
*  'FSERECRD' = ADDRESS OF FIRST 'FSE' RECORD
*
	 MOVE	   FSERECRD,$FPDD
	 SPACE 1
*  READ IN FIRST 'FSE' RECORD
*
	 READ	   DS$,DISKBUFR,1,FSERECRD,ERROR=RDERROR
	 SPACE 1
	 MOVE	   #1,+$$FSEFF				       V3M0GRB
	 MOVE	   #FISPAC1,#SPACERQ   PICK UP REC COUNT       V3M0GRB
	 MOVE	   SPACRQST,*,DWORD,P2=#FISPAC1		       V3M0GRB
	 SUBTRACT  SPACRQST,1,PREC=D SUBTRACT 1 SO WE CAN LOOK V3M0GRB
*				       DIRECTLY AT THE DIFFERENCE
*				       BETWEEN LFS AND FFS
	 MOVE	   WORKWD2,0,DWORD			       V3M0GRB
	 SPACE 1
*  'WORKWD1' = LAST FREE RECORD - FIRST FREE RECORD
*
FSPACE01 EQU	   *
	 SUBTRACT  (DISKBUFR+$$FSEL,#1),(DISKBUFR+$$FSEF,#1),RESULT=WORX
	       KWD1,PREC=DDD				       V3M0GRB
	 EJECT
	 SPACE 3
*  IS THIS BLOCK THE RIGHT SIZE?
*  GO TO 'FSPACE03' IF IT IS.
*
	 IF	   (WORKWD1,EQ,SPACRQST,DWORD),GOTO,FSPACE03   V3M0GRB
	 SPACE 1
*  IS THIS BLOCK BIG ENOUGH?
*
	 IF	   (WORKWD1,GT,SPACRQST,DWORD)		       V3M0GRB
	 SPACE 1
*  ..YES, IT IS BIG ENOUGH.
*  IS IT SMALLER THAN A BLOCK WE HAVE ALREADY FOUND?
*  IF SO, USE THIS ONE INSTEAD.
*
	 IF	   (WORKWD2,EQ,DZERO,DWORD),GOTO,FSPACE00      V3M0GRB
	 SPACE 1
	  IF	   (WORKWD1,LT,WORKWD2,DWORD)		       V3M0GRB
FSPACE00 EQU	   *
	    MOVE    WORKWD2,WORKWD1,DWORD     SAVE	       V3M0GRB
	    MOVE    FSECHNG+$FSEREC,FSERECRD  REC NO. OF FSE   V3M0GRB
	    MOVE    FSECHNG+$FSEDISP,#1   DISP OF FSE	       V3M0GRB
	    MOVE    FSECHNG+$FSEFFS,(DISKBUFR+$$FSEF,#1),(2,DWORD)
*			     FSE ITSELF			       V3M0GRB
	  ENDIF
	 SPACE 1
	 ENDIF
	 EJECT
	 SPACE 3
*  GO TO NEXT 'FSE' OR TO 'FSPACE02' IF END OF 'FSE' CHAIN
*
	 CALL	   FSESR1,(FSPACE02)
	 GOTO	   FSPACE01
	 SPACE 1
*  AT END OF THE SEARCH
*
FSPACE02 EQU	   *
*
*  DID WE FIND A BLOCK?  IF NOT, GO TO ERROR EXIT ADDRESS
*
	 IF	   (WORKWD2,EQ,DZERO,DWORD),GOTO,FSPACE04      V3M0GRB
	 SPACE 1
*  WE DO HAVE A BLOCK.	NOW WE HAVE TO
*
*    1) STORE FIRST AND LAST RECORD POINTERS FOR CALLER
*    2) UPDATE THE 'FSE' FROM WHICH IT CAME
*    3) UPDATE THE FREE RECORD COUNT IN THE 'DCE'
*
	 MOVE	   $FPMS,FSECHNG+$FSEFFS,DWORD	STRT REC ADDR  V3M0GRB
*  COMPUTE ENDING SECTOR ADDRESS
*
	 ADD	   $FPMS,SPACRQST,RESULT=$FPME,PREC=DDD        V3M0GRB
	 SPACE 1
	 ADD	   SPACRQST,1,PREC=D   RESET BACK TO INTL REQ  V3M0GRB
	 ADD	   FSECHNG+$FSEFFS,SPACRQST,PREC=DD  NEW FREE RV3M0GRB
	 SPACE 1
	 MOVEA	   #2,FSECHNG
	 CALL	   FSESR2	       REWRITE 'FSE'
	 SPACE 1
*  UPDATE THE DIRECTORY CONTROL ENTRY
*
	 SUBTRACT  $FPDE,SPACRQST,PREC=DD		       V3M0GRB
	 CALL	   DCESR1
	 RETURN
	 EJECT
	 SPACE 3
	 SPACE 1
*  AN EXACT MATCH WAS FOUND
*
*  WE MUST
*    1) STORE FIRST AND LAST RECORD ADDRESSES FOR CALLER
*    2) DELETE ITS 'FSE'
*    3) UPDATE THE 'DCE'
*
FSPACE03 EQU	   *
	 MOVE	   $FPMS,(DISKBUFR+$$FSEF,#1),(2,DWORD)        V3M0GRB
	 MOVE	   FSECHNG+$FSEREC,FSERECRD   STORE ADDR,REC   V3M0GRB
	 MOVE	   FSECHNG+$FSEDISP,#1	       AND DISP        V3M0GRB
	 SPACE 1
	 ADD	   SPACRQST,1,PREC=D   RESTORE REQUEST SIZE    V3M0GRB
	 SUBTRACT  $FPDE,SPACRQST,PREC=DD UPDT AVAIL REC CNT   V3M0GRB
*				       IN THE 'DCE'
	 MOVEA	   #2,LASTFSE
	 CALL	   FSESR3
	 SPACE 1
	 SUBTRACT  $FPDF,1	       DECREMENT 'FSE' COUNT IN 'DCE'
	 ADD	   $FPDB,+$$FSESIZ     INCRMENT FREE BYTE CNT  V3M0GRB
	 SPACE 1
	 MOVE	   FSECHNG+$FSEFFS,LASTFSE+$FSEFFS,(2,DWORD)   V3M0GRB
*		   MOVE IN   REPLACE DATA FROM THE LAST 'FSE'  V3M0GRB
	 MOVE	   LASTFSE+$FSEFFS,0,(2,DWORD)	CLR LAST 'FSE' V3M0GRB
	 SPACE 1
	 MOVEA	   #2,FSECHNG
	 CALL	   FSESR2	       REPLACE 'FSE' FOR BLOCK
*				       WE ARE GETTING WITH
*				       THE CURRENT LAST 'FSE'
	 SPACE 1
	 MOVEA	   #2,LASTFSE
	 CALL	   FSESR2	       DELETE CURRENT LAST 'FSE'
	 SPACE 1
	 CALL	   DCESR1	       GO UPDATE THE 'DCE'
	 SPACE 1
	 RETURN			       RETURN TO CALLER
	 SPACE 1
*  NO SPACE IS AVAILABLE
*
FSPACE04 EQU	   *
	 MOVE	   $FPMS,0,(2,DWORD)			       V3M0GRB
	 RETURN
	 SPACE 2
WORKWD1  DATA	   D'0'					       V3M0GRB
WORKWD2  DATA	   D'0'					       V3M0GRB
SPACRQST DATA	   D'0'					       V3M0GRB
DZERO	 DATA	   D'0'					       V3M0GRB
	 TITLE	   'SUBROUTINE - ***** RETFSE *****'
	 SPACE 3
	 SUBROUT   RETFSE
*
*  SUBROUTINE TO RETURN FREE SPACE ENTRY
*
************
	 SPACE 1
*  INCREMENT THE FREE RECORD COUNT IN THE 'DCE'
*
	 SUBTRACT  NEWLFS,NEWFFS,PREC=DD		       V3M0GRB
	 ADD	   $FPDE,NEWLFS,PREC=DD			       V3M0GRB
	 ADD	   $FPDE,1,PREC=D			       V3M0GRB
	 ADD	   NEWLFS,NEWFFS,PREC=DD		       V3M0GRB
	 SPACE	   1
	 MOVE	   FSECHNG+$FSEREC,0,6 CLEAR WORK AREA	       V3M0GRB
	 MOVE	   FSEFREE,$FPDF       'FSEFREE' = NO. OF FSE'S
	 SPACE 1
*  CALCULATE TEST FIRST FREE SECTOR NUMBER
*
	 SUBTRACT  NEWFFS,1,RESULT=NEWFFT,PREC=DSD	       V3M0GRB
	 SPACE 1
*  CALCULATE TEST LAST FREE SECTOR NUMBER
*
	 ADD	   NEWLFS,1,RESULT=NEWLFT,PREC=DSD	       V3M0GRB
	 SPACE 1
*  'FSERECRD' = ADDRESS OF FIRST 'FSE' RECORD
*
	 MOVE	   FSERECRD,$FPDD
	 MOVE	   #1,+$$FSEFF				       V3M0GRB
	 SPACE 1
*  READ IN LAST DIRECTORY SECTOR ('FSE' ORIGIN)
	 READ	   DS$,DISKBUFR,1,FSERECRD,ERROR=RDERROR
	 SPACE 1
*  CHECK FOR AN EMPTY FREE SPACE CHAIN
*
	 IF	   ($FPDF,GT,0),GOTO,RETFSE01		       V3M0GRB
	 SPACE 1
*  ..YES, IT IS EMPTY
*
	 MOVE	   FSECHNG+$FSEDISP,+$$FSEFF		       V3M0GRB
	 GOTO	   RETFSE35
	 SPACE 1
*  ..NO, IT IS NOT EMPTY
*
RETFSE01 EQU	   *
	 IF	   ((DISKBUFR+$$FSEF,#1),EQ,NEWLFT,DWORD)      PT00190
	  MOVE	   FSECHNG+$FSEREC,FSERECRD		       V3M0GRB
	  MOVE	   FSECHNG+$FSEDISP,#1			       V3M0GRB
	  MOVE	   FSECHNG+$FSELFS,(DISKBUFR+$$FSEL,#1),DWORD  V3M0GRB
	  GOTO	   RETFSE10
	 SPACE 1
	 ELSE
	   IF	     ((DISKBUFR+$$FSEL,#1),EQ,NEWFFT,DWORD)    V3M0GRB
	     MOVE     FSECHNG+$FSEREC,FSERECRD		       V3M0GRB
	     MOVE     FSECHNG+$FSEDISP,#1		       V3M0GRB
	     MOVE     FSECHNG+$FSEFFS,(DISKBUFR+$$FSEF,#1),DWORD
*							       V3M0GRB
	     GOTO     RETFSE20
	   ENDIF
	 ENDIF
	    SPACE 1
	 CALL	   FSESR1,(RETFSE30)
	 GOTO	   RETFSE01
	 EJECT
	 SPACE 3
*
*  NEW LAST FREE RECORD MATCHES WITH AN EXISTING FIRST FREE RECORD
*
*  NOW LOOK FOR A MATCH WITH THE NEW FIRST FREE RECORD
*
RETFSE10 EQU	   *
	 CALL	   FSESR1,(RETFSE15)
	 SPACE 1
      IF       ((DISKBUFR+$$FSEL,#1),NE,NEWFFT,DWORD),GOTO,RETFSE10
*							       V3M0GRB
	  MOVE	   FSECHNG+$FSEFFS,(DISKBUFR+$$FSEF,#1),DWORD  V3M0GRB
	  GOTO	   RETFSE50
	 SPACE 1
*  NO MATCH, USE THE NEW FIRST FREE RECORD ENTRY
*
RETFSE15 EQU	   *
	 MOVE	   FSECHNG+$FSEFFS,NEWFFS,DWORD		       V3M0GRB
	 GOTO	   RETFSE40
	 SPACE 3
*  NEW FIRST FREE RECORD MATCHES WITH AN EXISTING LAST FREE RECORD
*
*  NOW LOOK FOR A MATCH WITH THE NEW LAST FREE RECORD
*
RETFSE20  EQU	    *
	 CALL	   FSESR1,(RETFSE25)
	 SPACE 1
      IF       ((DISKBUFR+$$FSEF,#1),NE,NEWLFT,DWORD),GOTO,RETFSE20
*			MATCH FOUND			       V3M0GRB
	  MOVE	   FSECHNG+$FSELFS,(DISKBUFR+$$FSEL,#1),DWORD  V3M0GRB
	  GOTO	   RETFSE50
	 SPACE 1
*  NO MATCH, USE THE NEW LAST FREE RECORD ENTRY
*
RETFSE25 EQU	   *
	 MOVE	   FSECHNG+$FSELFS,NEWLFS,DWORD		       V3M0GRB
	 GOTO	   RETFSE40
	 EJECT
	 SPACE 3
*  NO MATCH WAS FOUND - ADD A NEW 'FSE' TO DIRECTORY
*
RETFSE30 EQU	   *
	 IF	   #1,EQ,0	       IS CURRENT RECORD FULL?
	  SUBTRACT FSERECRD,1	       ..YES, GET A NEW ONE
	  READ	   DS$,DISKBUFR,1,FSERECRD,ERROR=RDERROR
	  MOVE	   FSECHNG+$FSEDISP,+$$FSEFF		       V3M0GRB
	 SPACE 1
	 ELSE
	  SUBTRACT #1,+$$FSESIZ,RESULT=FSECHNG+$FSEDISP        V3M0GRB
	 ENDIF
	 SPACE 1
RETFSE35 EQU	   *
	 ADD	   $FPDF,1	       INCREMENT 'FSE' COUNT IN 'DCE'
	 SUBTRACT  $FPDB,+$$FSESIZ     DECRMNT FREE BYTE CNT   V3M0GRB
	 MOVE	   FSECHNG+$FSEREC,FSERECRD		       V3M0GRB
	 MOVE	   FSECHNG+$FSEFFS,NEWFFS,(2,DWORD)	       V3M0GRB
	 MOVEA	   #2,FSECHNG
	 CALL	   FSESR2	       GO ADD NEW 'FSE'
	 SPACE 1
	 GOTO	   RETFSE60	       GO UPDATE THE 'DCE'
	 EJECT
	 SPACE 3
*  THE NEW FREE SPACE IS CONTIGUOUS TO ONE (AND ONLY ONE)
*  EXISTING BLOCK.
*
*  ONE EXISTING 'FSE' MUST BE CHANGED
*
RETFSE40 EQU	   *
	 MOVEA	   #2,FSECHNG
	 CALL	   FSESR2	       UPDATE 'FSE'
	 SPACE 1
	 GOTO	   RETFSE60	       GO UPDATE THE 'DCE'
	 EJECT
	 SPACE 3
*  THE FREE SPACE IS CONTIGUOUS TO TWO EXISTING BLOCKS
*     (2 'FSE' MATCHES WERE FOUND)
*
*  THEREFORE, ONE 'FSE' MUST BE CHANGED, AND ONE DELETED
*
RETFSE50 EQU	   *
	 MOVE	   FSECHNG1,FSERECRD   STORE RECORD NO. OF     V3M0GRB
*				       THE 'FSE' TO BE DELETED
	 MOVE	   FSECHNG1+$FSEDISP,#1 STRE DSPLACEMENT TO IT V3M0GRB
	 MOVEA	   #2,LASTFSE	       GO GET
	 CALL	   FSESR3		INFO ON CURRENT LAST 'FSE'
	 SPACE 1
	 MOVE	   FSECHNG1+$FSEFFS,LASTFSE+$FSEFFS,(2,DWORD)	V3M0GRB
*	    MOVE IN  REPLACEMENT DATA FROM THE LAST 'FSE'	V3M0GRB
	 MOVE	   LASTFSE+$FSEFFS,0,(2,DWORD)	CLR  LAST 'FSE' V3M0GRB
	 SUBTRACT  $FPDF,1	       DECREMENT 'FSE' COUNT IN 'DCE'
	 ADD	   $FPDB,+$$FSESIZ     INCREMENT FREE BYTE CNT	V3M0GRB
	 SPACE 1
	 MOVEA	   #2,FSECHNG
	 CALL	   FSESR2	       UPDATE FIRST 'FSE'
	 SPACE 1
	 ADD	   #2,12					V3M0GRB
	 CALL	   FSESR2	       REPLACE SECOND 'FSE' WITH
*				       OLD LAST 'FSE'
	 SPACE 1
	 MOVEA	   #2,LASTFSE	       OLD LAST FSE   S200583	V3M0GRB
	 CALL	   FSESR2	       RESET OLD LAST 'FSE'
	 SPACE 1
RETFSE60 EQU	   *
	 CALL	   DCESR1
	 RETURN
	 TITLE	   'SUBROUTINE - ***** FSESR1 *****'
	 SPACE 3
	 SUBROUT   FSESR1,FSEEND
*
*  SUBROUTINE TO
*    1) DECREMENT FREE COUNT AND INDEX REGISTER
*    2) TEST FOR END OF RECORD AND READ NEW RECORD IF SO
*    3) TEST FOR END OF FSE'S
*
*  BRANCHES TO ADDRESS PASSED IF 'FSE' COUNT IS EXHAUSTED
*
*  RETURNS OTHERWISE
*
************
	 SPACE 1
	 SUBTRACT  FSEFREE,1	       DECREMENT 'FSE' COUNT
	 IF	   FSEFREE,LE,0
	  GOTO	   (FSEEND)
	  ENDIF
	 SPACE 1
	 SUBTRACT  #1,+$$FSESIZ       DECREMENT INDEX REGISTER V3M0GRB
	 IF	   #1,LT,0	       IF AT END OF RECORD
	   MOVE      #1,+$$FSEFF			       V3M0GRB
	   SUBTRACT FSERECRD,1		  DECREMENT DISK POINTER
*					 READ NEW RECORD
	   READ     DS$,DISKBUFR,1,0,P4=FSERECRD,ERROR=RDERROR
	 ENDIF
	 SPACE 1
	 RETURN
	 TITLE	   'SUBROUTINE - ***** FSESR2 *****'
	 SPACE 3
	 SUBROUT   FSESR2
*
*  SUBROUTINE TO WRITE A 'FSE'
*
*   ON ENTRY, INDEX REGISTER #2 SHOULD BE POINTING TO A        V3M0GRB
*   TABLE WITH THE FOLLOWING FORMAT.
*
*      WD1 - NUMBER OF THE RECORD INTO WHICH THE 'FSE' IS TO BE WRITTEN
*
*      WD2 - DISPLACEMENT INTO RECORD FOR 'FSE'
*
*      WD3 - FIELD 1 OF 'FSE' (FIRST FREE RECORD)   DW	       V3M0GRB
*
*      WD4 - FIELD 2 OF 'FSE' (LAST FREE RECORD)    DW	       V3M0GRB
*
*  THE WORD 'FSERECRD' MUST CONTAIN THE NUMBER OF THE DIRECTORY
*  RECORD WHICH IS CURRENTLY IN STORAGE.  'FSERECRD' WILL BE UPDATED
*  BY THIS SUBROUTINE
*
*********
	 SPACE 1
*  TEST TO SEE IF TARGET RECORD IS ALREADY IN STORAGE
*
	 IF	   (0,#2),EQ,FSERECRD,FSESR2A
*				       NO IT ISN'T - READ IT IN
	 MOVE	   FSERECRD,(0,#2)
	 READ	   DS$,DISKBUFR,1,FSERECRD,ERROR=RDERROR
	 SPACE 1
*  TARGET RECORD IS IN STORAGE NOW
*
*  STORE THE NEW ENTRY
*
FSESR2A  EQU	   *
	 MOVEA	   FSESR2B,DISKBUFR    POINT TO DISK BUFFER
	 ADD	   FSESR2B,($FSEDISP,#2)      ADD DISPLACEMENT
	 MOVE	   *,($FSEFFS,#2),(2,DWORD),P1=FSESR2B	       V3M0GRB
	 SPACE 1
*  REWRITE RECORD
*
	 WRITE	   DS$,DISKBUFR,1,FSERECRD,ERROR=WDERROR
	 SPACE 1
	 RETURN
	 TITLE	   'SUBROUTINE - ***** FSESR3 *****'
	 SPACE 1
	 SUBROUT   FSESR3
*
*  SUBROUTINE TO FIND THE LAST 'FSE'
*     LOCATION
*
*  ENTRY CONDITIONS
*     #2 POINTING TO A 6 WORD AREA FOR RESULTS STORAGE	       V3M0GRB
*
*  EXIT CONDITIONS
*     THE 6 WORD AREA WILL BE FILLED IN AS FOLLOWS	       V3M0GRB
*
*	 WD1 - RECORD ADDRESS OF THE LAST 'FSE'
*	 WD2 - DISPLACEMENT OF THE LAST 'FSE'
*	 DWD3 - FIRST PART OF LAST 'FSE'		       V3M0GRB
*	 DWD4 - SECOND PART OF LAST 'FSE'		       V3M0GRB
**********
	 SPACE 1
*  ARE THERE ANY 'FSE'S?
*
	 IF	   $FPDF,EQ,0	       IS 'DCE' ENTRY NON-ZERO?
	   MOVE    ($FSEREC,#2),0,6	..NO, CLR 6 WRDS TO 0  V3M0GRB
	  SPACE 1
	   RETURN
	 ENDIF
	 SPACE 1
*  CALCULATE ADDRESS OF AND READ IN THE RECORD CONTAINING LAST 'FSE'
*
	 MOVE	   ($FSEREC,#2),$FPDD
	 SUBTRACT  $FPDF,1,RESULT=FSESR3D
	 SHIFTR    FSESR3D,5	     DIVIDE BY 32	       V3M0GRB
	 SUBTRACT  ($FSEREC,#2),0,P2=FSESR3D
	 SPACE 1
*  CALCULATE THE DISPLACEMENT TO THE LAST 'FSE'
*
	 AND	   $FPDF,X'001F',RESULT=FSESR3A		       V3M0GRB
	 SHIFTL    FSESR3A,3	     MULTIPLY BY 8	       V3M0GRB
	 MOVE	   ($FSEDISP,#2),256
	 SUBTRACT  ($FSEDISP,#2),0,P2=FSESR3A
	 AND	   ($FSEDISP,#2),X'00FF'  LIMIT TO<256 S200583 V3M0GRB
	 SPACE 1
*  READ IN RECORD AND STORE 'FSE' ENTRY
*
	 MOVE	   FSERECRD,($FSEREC,#2) STR TGT REC NOS200582 V3M0GRB
	 READ	   DS$,DISKBUFR,1,FSERECRD,ERROR=RDERROR S2582 V3M0GRB
	 SPACE 1
	 MOVEA	   FSESR3C,DISKBUFR
	 ADD	   FSESR3C,($FSEDISP,#2)
	 MOVE	   ($FSEFFS,#2),*,(2,DWORD),P2=FSESR3C	       V3M0GRB
	 SPACE 1
	 RETURN
	 TITLE	   'SUBROUTINE - ***** DCESR1 *****'
	 SPACE 3
	 SUBROUT   DCESR1
*
*  SUBROUTINE TO REWRITE DESCRIPTOR CONTROL ENTRY ('DCE')
*
************
	 SPACE 1
	 READ	   DS$,DISKBUFR,1,1,ERROR=RDERROR
	 SPACE 1
	 MOVE	   DISKBUFR,$FPDS,(32,BYTES)		       V3M0GRB
	 SPACE 1
	 WRITE	   DS$,DISKBUFR,1,1,ERROR=WDERROR
	 SPACE 1
	 RETURN
	 TITLE	   ' '
	 SPACE 3
*  WORKING STORAGE AREAS FOR 'FSE' AND 'DCE' MANIPULATION
*
FSECHNG  DATA	   6F'0'				       V3M0GRB
*				       WD1 = NO. OF 'FSE' RECORD
*				       WD2 = DISPLACEMENT INTO IT
*				       DWD3 = NEW FRST FR RCRD V3M0GRB
*				       DWD4 = NEW LAST FR RCRD V3M0GRB
*
FSECHNG1 DATA	   6F'0'	       AN EXTRA ONE	       V3M0GRB
LASTFSE  DATA	   6F'0'	       ONE FOR THE LAST 'FSE'  V3M0GRB
*
NEWFFS	 DATA	   D'0'					       V3M0GRB
NEWLFS	 DATA	   D'0'					       V3M0GRB
NEWFFT	 DATA	   D'0'					       V3M0GRB
NEWLFT	 DATA	   D'0'					       V3M0GRB
*
FSEFREE  DATA	   F'0'		       'FSE' COUNTER
	 SPACE 1
*  EQUATES FOR 6 WORD TABLE USED IN CALLING 'FSE' SUBROUTINES  V3M0GRB
*
$FSEREC  EQU	   0
$FSEDISP EQU	   $FSEREC+2
$FSEFFS  EQU	   $FSEDISP+2
$FSELFS  EQU	   $FSEFFS+4				       V3M0GRB
*
