***********************************************************
*							  *
*  SUBROUTINE TO POSITION A TAPE DATASET CORRECTLY FOR	  *
* UPDATE AND PRESERVE THE DATASET LENGTH.		  *
*							  *
*  CALLING SEQUENCE:  (AFTER A CALL TO DSOPEN)		  *
*	   CALL  UPDTAPE,(DSX)				  *
*	   WHERE 'DSX' IS THE DSCB			  *
*							  *
*  RETURN CODES IN 1ST WORD OF DSCB:			  *
*	  -1 = ALL IS OK				  *
*	  XX = ERROR					  *
*							  *
***********************************************************
	 SUBROUT UPDTAPE,UP@TDS
	 MOVE	 UP@@05,#1,2		       SAVE #1 AND #2
	 MOVE	 #1,UP@TDS		       GET DSCB ADDR IN #1
	 MOVE	 #2,($DSCBVDE,#1)	       GET VDE ADDRESS
	 MOVE	 #2,($VOLDDB,#2),FKEY=0        GET TDB ADDRESS IN #2
	 MOVE	 UP@@01,($TDBTYPE,#2),FKEY=0   GET DEVICE ID
	 IF	 (UP@@01,NE,X'3186')	       IF NOT A TAPE
	   MOVE  (0,#1),30			 SET RC=30
	   GOTO  UP@END				 AND EXIT
	 ENDIF				       +
	 MOVE	 UP@@01,($TDBVFLG,#2),FKEY=0   GET FLAGS
	 AND	 UP@@01,X'0300'		       GET LABEL PROCESSING
	 MOVE	 UP@FSF+10,UP@TDS	       SET DSCB ADDR IN INSTN
	 MOVE	 UP@BSF1+10,UP@TDS	       SET DSCB ADDR IN INSTN
	 MOVE	 UP@BSF2+10,UP@TDS	       SET DSCB ADDR IN INSTN
	 MOVE	 UP@READ+10,UP@TDS	       SET DSCB ADDR IN INSTN
	 MOVE	 UP@CLS+10,UP@TDS	       SET DSCB ADDR IN INSTN
UP@FSF	 CONTROL *,FSF,WAIT=YES,ERROR=UP@END   SPACE TO LAST TAPEMARK
	 IF	 (UP@@01,NE,X'0100')	       IF NOT STD LABEL
UP@BSF1    CONTROL *,BSF,WAIT=YES		  BACK OVER TAPEMARK
	   GOTO    UP@END			  AND RETURN
	 ENDIF				       ENDIF
	 MOVE	 UP@@02,X'4040'		       INITIALIZE BUFFER
UP@READ  READ	 *,UP@@02,1,80,WAIT=YES,ERROR=UP@CLS
	 IF	 (UP@@02,NE,UP@@EOF1,DWORD)
UP@CLS	   CONTROL *,CLSRU		       CLOSE
	   GOTO    UP@END		       AND RETURN
	 ENDIF
UP@BSF2  CONTROL *,BSF,WAIT=YES,ERROR=UP@END	BACK OVER TAPEMARK
	 CONVTD    UP@@03,UP@@02+X'36',FORMAT=(6,0,I),PREC=D
	 MOVE	 ($DSCBLNG,#1),UP@@03,DWORD	SET NEW LENGTH
	 ADD	 UP@@03,UP@@04,PREC=D		ADD 1 TO LENGTH
	 MOVE	 ($DSCBNEX,#1),UP@@03,DWORD	SET NEW NEXT
	 MOVE	 ($TDBREC#,#2),UP@@03,DWORD,TKEY=0  SET NEW NEXT
UP@END	 EQU	 *				RETURN TO CALLER
	 MOVE	 #1,UP@@05,2			RESTORE #1 AND #2
	 RETURN					GO AWAY
	 SPACE 1
UP@@01	 DC	 F'0'		   LABEL TYPE
UP@@02	 DC	 40F'0'		   BUFFER
UP@@03	 DC	 D'0'		   CONVERT TARGET AREA
UP@@04	 DC	 D'1'		   DOUBLE WORD 1
UP@@05	 DC	 D'0'		   SAVE AREA FOR #1 AND #2
UP@@EOF1 DC	 C'EOF1'	   EOF1 INDICATOR
	 SPACE	 2
